const { JsonWebTokenError } = require("jsonwebtoken");

class ProductController {
    constructor(){
        this.promoProducts = []
    }    
    get(req, res){
        res.send(`<pre>
        Please request in POST mode with params like this: <br/> 
        {
            CDFILIAL: '0008',
            CDTABEPREC: '007',
            DTINIVGPREC: '2019-11-25 00:00:00',
            CDLOJA: "01",
            NRCONFTELA: "00010"
        }</pre>
        `)
    }
    verify(req, res, next){
        //if( jwt.verify())
        res.send('não está autorizado')
    }

    getPromoProducts(req, res, next){
        let filterParams = req.body;

        let self = req.app.controller.ProductController

        let today = new Date()
        filterParams.NRDIASEMANABLOQ = today.getDay()+1;
        filterParams.NRDIASEMANPR = today.getDay()+1;
        filterParams.DTINIVGPREC = filterParams.DTINIVGPREC;
        filterParams.HORA = ('00'+today.getHours()).substr(-2)+('00'+today.getMinutes()).substr(-2)
        req.app.model.ProductModel.getPromoProducts(req.app,filterParams).then( result => {
            self.promoProducts = self.handleItems(result.recordsets[0])
            res.send(self.promoProducts)
        })
        // if(self.promoProducts.length > 0 && 1 == 2){
        //     res.send(self.promoProducts)
        // } else {
        // }
    }

    handleItems(data){
        let items = []
        let currentProduct = ''
        let currentGroup = ''
        let currentGroupMutex = ''
        let currentProdGrupromoc = ''
        let product = {}
        let sinteticGroup = []
        let group = {}
        let prodGrupromoc = {}
        let newGroup = false;

        data.forEach( element => {
            if(element.DSBUTTON != currentProduct){
                currentProduct = element.DSBUTTON
                product = {}
                product.name = currentProduct
                product.CDPRODPROMOCAO = element.CDPRODPROMOCAO
                product.groups = []
                product.price = 0.00
                items.push(product)
            }

            if(element.CDGRUPROMOC != currentGroup){
                if( !element.CDGRUPMUTEX){
                    sinteticGroup = null;
                    currentGroupMutex = null
                } else {
                    if(currentGroupMutex !== element.CDGRUPMUTEX){
                        currentGroupMutex = element.CDGRUPMUTEX
                        sinteticGroup = {}
                        sinteticGroup.IDMODOEXIBETAA = element.IDMODOEXIBETAA
                        sinteticGroup.CDPRODPROMOCAO = element.CDPRODPROMOCAO
                        sinteticGroup.NRORDPROMOGRUP = element.NRORDPROMOGRUP
                        sinteticGroup.price = 0.00
                        sinteticGroup.minPrice = 0.00
                        sinteticGroup.preSelectPrice = 0.00
                        sinteticGroup.title = this.buildHeaderTitle(element)
                        sinteticGroup.CDGRUPMUTEX = element.CDGRUPMUTEX
                        sinteticGroup.subgroups = []
                        product.groups.push(sinteticGroup)
                    } else {
                        sinteticGroup.title = `${sinteticGroup.title} ou${this.buildHeaderTitle(element).replace('Escolha', '')}`  
                    }
                }

                currentGroup = element.CDGRUPROMOC
                if(group.preSelectPrice > 0.00){
                    group.minPrice = 0.00;
                }

                group = {}
                
                group.name = element.NMGRUPROMOC.toString();
                group.NMGRUPROMOC = element.NMGRUPROMOC.toString();
                
                group.IDMODOEXIBETAA = element.IDMODOEXIBETAA;
                group.CDPRODPROMOCAO = element.CDPRODPROMOCAO;
                group.NRORDPROMOGRUP = element.NRORDPROMOGRUP;
                group.nmGrupMutex = element.DSGROUPTAA
                group.title = this.buildHeaderTitle(element)
                group.CDGRUPMUTEX = element.CDGRUPMUTEX
                group.CDGRUPROMOC = element.CDGRUPROMOC
                group.QTPRGRUPROMIN = element.QTPRGRUPROMIN
                group.QTPRGRUPPROMOC = element.QTPRGRUPPROMOC
                group.price = 0
                group.minPrice = 0.00
                group.preSelectPrice = 0.00
                group.products = []

                if(!!element.CDGRUPMUTEX){
                    sinteticGroup.subgroups.push(group)
                    product.groups.push(group)
                } else {
                    product.groups.push(group)
                }

                newGroup = true;

            }

            if(element.CDPRODUTO != currentProdGrupromoc){
                currentProdGrupromoc = element.CDPRODUTO
                prodGrupromoc = {}
                prodGrupromoc.name = element.NMPRODUTO
                prodGrupromoc.NMPRODUTO = element.NMPRODUTO
                prodGrupromoc.CDPRODUTO = element.CDPRODUTO
                prodGrupromoc.CDGRUPROMOC = element.CDGRUPROMOC
                prodGrupromoc.PRICE = {
                    'VRPRECITEM': element.VRPRECITEM, // VALOR DO PRODUTO NA TABELA DE PRECO
                    'DIFF_PRICE': element.DIFF_PRICE, // VALOR DO DESCONTO / ACRESCIMO DA TABELA DE PRECO
                    'IDPERVALORPR': element.IDPERVALORPR, // PERCENTUAL OU VALOR DA TABELA DE PRECO
                    'IDDESCACREPR': element.IDDESCACREPR, // DESCONTO OU ACRESCIMO DA TABELA DE PRECO
                    'CDTIPOCONSPD': element.CDTIPOCONSPD,
                    'HRINIPRECDIA': element.HRINIPRECDIA,
                    'HRFINPRECDIA': element.HRFINPRECDIA,
                }
                prodGrupromoc.IDVISUACUPOM = element.IDVISUACUPOM
                prodGrupromoc.IDPERVALORDES = element.IDPERVALORDES // PERCENTUAL OU VALOR DO PRODGRUPROMOC
                prodGrupromoc.VRDESPRODPROMOC = element.VRDESPRODPROMOC //VALOR DO DESCONTO / ACRESCIMO DO PRODGRUPROMOC
                prodGrupromoc.IDDESCACRPROMO = element.IDDESCACRPROMO // DESCONTO OU ACRESCIMO DO PRODGRUPROMOC
                prodGrupromoc.IDAPLICADESCPR = element.IDAPLICADESCPR
                prodGrupromoc.IDPRODPRESELEC = element.IDPRODPRESELEC
                prodGrupromoc.IDOBRPRODSELEC = element.IDOBRPRODSELEC
                prodGrupromoc.IDPRINCPROD = element.IDPRINCPROD
                prodGrupromoc.QTPRODVEND = 0
                
                if(newGroup){
                    newGroup = false;
                    group.minPrice += element.VRPRECITEM * element.QTPRGRUPROMIN
                }

                if(element.IDPRODPRESELEC == 'S'){
                    group.preSelectPrice += element.VRPRECITEM
                }

                group.products.push(prodGrupromoc)
            }                
        })

        items.forEach( (item, i) => {
            items[i].price = 0
            items[i].groups.forEach( subitem => {
                items[i].price += subitem.minPrice + subitem.preSelectPrice;
                let minPriceDone = false;
                let currentMinPrice = 0.00;
                let preSelectPriceDone = false;
                // if( !!subitem.subgroups){
                //     subitem.subgroups.forEach( subgroup => {
                //         if(subgroup.minPrice > 0 && !minPriceDone && !preSelectPriceDone){
                //             items[i].price += subgroup.minPrice;
                //             currentMinPrice = subgroup.minPrice;
                //             minPriceDone = true;
                //         }
                //         if(subgroup.preSelectPrice > 0 && !preSelectPriceDone){
                //             items[i].price += (subgroup.preSelectPrice - currentMinPrice);
                //             preSelectPriceDone = true;
                //         }                        
                //    })
                // }                
            })
            items[i].price = items[i].price.toFixed(2)
        })

        

        return items;
    }

    buildHeaderTitle(promoGroup) {
        const min = parseInt(promoGroup.QTPRGRUPROMIN)
        const max = parseInt(promoGroup.QTPRGRUPPROMOC)
        let title = ''
        if(min === 0) {
            title = `Escolha até ${max} ${promoGroup.NMGRUPROMOC}`
        }
        if(min > 0 && min < max) {
            title = `Escolha de ${min} até ${max} ${promoGroup.NMGRUPROMOC}`
        }
        if(min === max) {
            title = `Escolha ${max} ${promoGroup.NMGRUPROMOC}`
        }
        return title
    }
}

module.exports = new ProductController()