const moment = require('moment');

class DateHandler {

  constructor() {
    this.dateFormat = 'YYYY-MM-DD';
    this.timeFormat = 'HH:mm:ss';
  }

  getFormat(useTime, format) {
    if(typeof format === 'string') return format;
    if(useTime) return `${this.dateFormat} ${this.timeFormat}`;
    return this.dateFormat;
  }

  toString({ useTime = false, format = null } = {}) {
    return moment().format(this.getFormat(useTime, format));
  }

}

module.exports = new DateHandler();