const admZip = require('adm-zip');
const fs = require('fs');

const route = (router) => {
  router.get('/versions', (async (req, res) => {
    try {
      let serviceId = '';

      if (typeof req.query.serviceId === 'string') {
        serviceId = req.query.serviceId;
      }

      if (!serviceId) {
        return res.status(400).json({
          message: 'Service Name cannot be null.',
        });
      }

      const aplicacao = req.query.serviceId;
      const dirApp = '../../../../../assistant-sistemas/';
      let dir = `${dirApp + aplicacao}/`;
      dir = path.join(__dirname, dir);

      if (!dir) {
        return res.status(400).json({ error: 'Service folder not found' });
      }

      const zip = new admZip();
      const files = fs.readdirSync(dir);

      files.forEach((file) => {
        if (fs.statSync(dir + file).isDirectory()) {
          zip.addLocalFolder(path.resolve(dir, file), file);
        } else {
          zip.addLocalFile(`${dir}/${file}`);
        }
      });

      const name = `${dirApp + aplicacao}}.zip`;
      const dirZip = path.join(`${__dirname}`, name);
      zip.writeZip(dirZip);
      const buff = zip.toBuffer();
      /** arquivo nome DANIEL-V0.0.1.zip */
      fs.unlinkSync(dirZip);

      return res.send(buff);
    } catch (error) {
      res.send(error);
    }
  }));
}

module.exports = route;