const OracleService = require('../service/OracleService');

class UpdaterServiceManagementModel {

  async filterServiceManagementFili() {
    const sql = `    
      SELECT   
        U.CDFILIAL, 
        F.CDFILIAL || ' - ' || F.NMFILIAL AS FILIAL        
      FROM
        UPDATERSERVICOFILI U
        LEFT JOIN FILIAL F ON (F.CDFILIAL = U.CDFILIAL)
      WHERE   
        MONITORAMENTO IS NOT NULL`;

    return await OracleService.fetchAssoc(sql);
  };

  async filterServiceManagementMonitoring(cdFilial) {
    const sql = `
      SELECT       
        CDFILIAL,
        MONITORAMENTO
      FROM 
        UPDATERSERVICOFILI
      WHERE 
        CDFILIAL = :CDFILIAL    
    `;

    const param = {
      CDFILIAL: cdFilial
    };

    return await OracleService.fetchAssoc(sql, param);
  }
}

module.exports = new UpdaterServiceManagementModel();